'From Squeak2.8 of 13 June 2000 [No updates present.] on 23 March 2001 at 3:13:16 pm'!
"Change Set:		SUnit3.0Fixes
Date:			22 February 2001
Author:			Andres Valloud

Fixes & Refactorings for SUnit3.0"!

!TestResource methodsFor: 'Init / Release' stamp: 'Sames 2/21/2001 12:09'!
initialize

	self setUp
! !


Model subclass: #TestRunner
	instanceVariableNames: 'result details passFail failures errors tests testSuite passFailText detailsText lastPass testsList selectedFailureTest selectedErrorTest selectedSuite '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnit-UI'!

!TestRunner commentStamp: '<historical>' prior: 0!
A simple text-based user interface to run all the test cases that exist in this image within the SUnit framework by Kent Beck and Erich Gamma (SUnit release 2, November 1998). The tests can be executed via TestRunner runTests or TestRunner runTests: '* test*'. The test results appear in the Transcript window.!
TestRunner class
	instanceVariableNames: ''!

!TestCase methodsFor: 'Printing' stamp: 'SqR 2/20/2001 16:02'!
printOn: aStream

	testSelector == nil ifTrue: [super printOn: aStream. ^self].
	aStream nextPutAll: self class printString.
	aStream nextPutAll: '>>'.
	aStream nextPutAll: testSelector! !

!TestCase methodsFor: 'Private' stamp: 'SqR 1/23/2001 16:53'!
executeShould: aBlock inScopeOf: anExceptionalEvent 
	"Answer true if evaluating aBlock produces anExceptionalEvent.
	Answer false if evaluating aBlock produces a different exceptional event,
		or if it does not produce an exceptional event at all"

	^[
		[aBlock value. false] "If it runs without an error, it's a failure"
			sunitOn: anExceptionalEvent
			do: [:ex | ex return: true] "If it raises the proper exception, it's a pass"
	]
		sunitOn: TestResult error
		do: [:ex | ex return: false] "If it does not raise the proper exception, it's a failure"! !


!TestCase class methodsFor: 'Accessing' stamp: 'reThink 3/13/2001 13:07'!
allTestSelectors

	| selectors currentClass |
	selectors := self selectors.
	currentClass := self.
	[currentClass == TestCase] whileFalse:
		[
			currentClass := currentClass superclass.
			selectors addAll: currentClass selectors.
		].
	^selectors asSortedCollection asOrderedCollection
		select: [:each | 'test*' sunitMatch: each]! !

!TestCase class methodsFor: 'Accessing' stamp: 'reThink 3/13/2001 13:07'!
testSelectors
	^self sunitSelectors select: [:each | 'test*' sunitMatch: each]! !


!TestRunner methodsFor: 'constants' stamp: 'SSS 7/5/2000 13:53'!
debugButtonLabel
        ^ 'DEBUG'! !

!TestRunner methodsFor: 'constants' stamp: 'SSS 7/5/2000 14:08'!
debugState

        ^true! !

!TestRunner methodsFor: 'constants' stamp: 'Sames 4/11/2000 19:13'!
errorColor
        ^ Color red! !

!TestRunner methodsFor: 'constants' stamp: 'Sames 4/11/2000 19:13'!
failColor
        ^ Color yellow! !

!TestRunner methodsFor: 'constants' stamp: 'Sames 4/11/2000 19:13'!
passColor
        ^ Color green! !

!TestRunner methodsFor: 'constants' stamp: 'SSS 7/5/2000 13:53'!
refreshButtonLabel
        ^ 'REFRESH'! !

!TestRunner methodsFor: 'constants' stamp: 'SSS 7/5/2000 13:59'!
refreshButtonState

        ^true! !

!TestRunner methodsFor: 'constants' stamp: 'SSS 7/5/2000 14:30'!
resetColor
        ^ Color white! !

!TestRunner methodsFor: 'constants' stamp: 'Sames 4/11/2000 19:32'!
runButtonColor
        ^ Color yellow! !

!TestRunner methodsFor: 'constants' stamp: 'Sames 4/11/2000 18:14'!
runButtonLabel
        ^ 'RUN ALL'! !

!TestRunner methodsFor: 'constants' stamp: 'Sames 4/11/2000 17:32'!
runButtonState

        ^true! !

!TestRunner methodsFor: 'constants' stamp: 'Sames 4/11/2000 18:17'!
runOneButtonLabel
        ^ 'RUN'! !

!TestRunner methodsFor: 'constants' stamp: 'Sames 2/22/2001 10:22'!
windowLabel

        ^'SUnit Camp Smalltalk 3.0 Test Runner'! !

!TestRunner methodsFor: 'processing' stamp: 'rew 8/23/2000 20:44'!
debugErrorTest: anInteger
        selectedErrorTest _ anInteger.  "added rew"
        selectedFailureTest _ 0.                        "added rew"
        self changed: #selectedFailureTest.             "added rew"
        self changed: #selectedErrorTest.               "added rew"
        (anInteger ~= 0)
                ifTrue: [(result errors at: anInteger) debug]! !

!TestRunner methodsFor: 'processing' stamp: 'rew 8/23/2000 21:49'!
debugFailureTest: anInteger

        (anInteger ~= 0)
                ifTrue: [(result failures at: anInteger) debugAsFailure].

        selectedFailureTest _ anInteger.
        selectedErrorTest _ 0.
        self changed: #selectedErrorTest.
        self changed: #selectedFailureTest.
! !

!TestRunner methodsFor: 'processing' stamp: 'SSS 7/5/2000 13:59'!
debugTest! !

!TestRunner methodsFor: 'processing' stamp: 'SqR 1/24/2001 15:59'!
refreshTests
	self loadTests.
	testSuite := nil.
	self changed: #selectedFailureTest.             "added rew"
	self changed: #selectedErrorTest.               "added rew"
	self changed: #selectedSuite.
	self refreshWindow! !

!TestRunner methodsFor: 'processing' stamp: 'Sames 2/22/2001 10:19'!
runOneTest
        Cursor execute showWhile:
                [testSuite notNil
                        ifTrue:
                                [self runWindow.
                                result _ testSuite asSymbol sunitAsClass suite run.
                                self updateWindow: result]
                        ifFalse:
                                [self runWindow.
                                self displayPassFail: 'No Test Suite Selected']]! !

!TestRunner methodsFor: 'processing' stamp: 'rew 8/23/2000 21:05'!
runTests
        Cursor execute showWhile:
                [self runWindow.
                result _ self suite run.
                self updateWindow: result]! !

!TestRunner methodsFor: 'processing' stamp: 'rew 5/15/2000 21:08'!
selectedErrorTest
        ^selectedErrorTest! !

!TestRunner methodsFor: 'processing' stamp: 'rew 8/23/2000 21:01'!
selectedFailureTest

        ^selectedFailureTest! !

!TestRunner methodsFor: 'processing' stamp: 'rew 5/15/2000 21:08'!
selectedSuite

        ^selectedSuite! !

!TestRunner methodsFor: 'processing' stamp: 'rew 8/23/2000 20:52'!
selectedSuite: anInteger
        anInteger ~= 0 ifTrue: [testSuite _ tests at: anInteger].
        selectedSuite _ selectedSuite = anInteger
                                        ifTrue:[0]
                                        ifFalse:[anInteger].
        selectedFailureTest _ 0.
        selectedErrorTest _ 0.
        self changed: #selectedFailureTest.             "added rew"
        self changed: #selectedErrorTest.               "added rew" 
        self changed: #selectedSuite.! !

!TestRunner methodsFor: 'interface opening' stamp: 'reThink 3/9/2001 20:27'!
buttons

	^self dependents 
		select: 
			[:each | 
			each respondsTo: #getModelState]! !

!TestRunner methodsFor: 'interface opening' stamp: 'reThink 3/9/2001 20:15'!
detailsText

	^(self dependents select: [:v | v respondsTo: #getTextSelector])
		detect: [:t | #details = t getTextSelector]
		ifNone: [nil]! !

!TestRunner methodsFor: 'interface opening' stamp: 'reThink 3/9/2001 20:38'!
open

	self class
		openViewSpec: self class defaultViewSpecification
		on: self.
	self buttons
		do:
			[:eachButton |
			eachButton color: self runButtonColor.
       		eachButton 
				onColor: self runButtonColor 
				offColor: self runButtonColor]! !

!TestRunner methodsFor: 'interface opening' stamp: 'reThink 3/9/2001 20:13'!
passFailText

	^(self dependents select: [:v | v respondsTo: #getTextSelector])
		detect: [:t | #passFail = t getTextSelector]
		ifNone: [nil]! !

!TestRunner methodsFor: 'accessing' stamp: 'Sames 4/11/2000 17:25'!
details

        ^details! !

!TestRunner methodsFor: 'accessing' stamp: 'Sames 4/11/2000 17:25'!
errors

        ^errors! !

!TestRunner methodsFor: 'accessing' stamp: 'Sames 4/11/2000 17:26'!
failures

        ^failures! !

!TestRunner methodsFor: 'accessing' stamp: 'Sames 4/12/2000 18:12'!
formatTime: aTime
        aTime hours > 0 ifTrue: [^aTime hours printString , 'h'].
        aTime minutes > 0 ifTrue: [^aTime minutes printString , 'min'].
        ^aTime seconds printString , ' sec'! !

!TestRunner methodsFor: 'accessing' stamp: 'Sames 4/11/2000 17:26'!
passFail

        ^passFail! !

!TestRunner methodsFor: 'accessing' stamp: 'Sames 2/22/2001 10:14'!
suite
        ^TestCase buildSuite! !

!TestRunner methodsFor: 'accessing' stamp: 'Sames 4/11/2000 18:39'!
tests
        ^ tests! !

!TestRunner methodsFor: 'accessing' stamp: 'Sames 4/12/2000 18:19'!
timeSinceLastPassAsString: aResult
        (lastPass isNil or: [aResult hasPassed not]) ifTrue: [^ ''].
        ^ ', ' , (self formatTime: (Time now subtractTime: lastPass)) , '
since last Pass'! !

!TestRunner methodsFor: 'initialize' stamp: 'SqR 1/24/2001 16:00'!
initialize

	result := TestResult new.
	passFail := 'N/A'.
	details := '...'.
	failures := OrderedCollection new.
	errors := OrderedCollection new.
	self loadTests! !

!TestRunner methodsFor: 'initialize' stamp: 'SqR 1/24/2001 16:00'!
loadTests

	tests := (TestCase allSubclasses collect: [:each | each name]) asSortedCollection.
	selectedSuite := 0.
	selectedFailureTest := 0.
	selectedErrorTest := 0.
	self changed: #tests
! !

!TestRunner methodsFor: 'updating' stamp: 'Sames 4/11/2000 17:38'!
displayDetails: aString
        details := aString.
        self changed: #details! !

!TestRunner methodsFor: 'updating' stamp: 'Sames 4/11/2000 17:37'!
displayErrors: anOrderedCollection

        errors := anOrderedCollection.
        self changed: #errors! !

!TestRunner methodsFor: 'updating' stamp: 'Sames 4/11/2000 17:37'!
displayFailures: anOrderedCollection

        failures := anOrderedCollection.
        self changed: #failures! !

!TestRunner methodsFor: 'updating' stamp: 'Sames 4/11/2000 17:36'!
displayPassFail: aString
        passFail := aString.
        self changed: #passFail! !

!TestRunner methodsFor: 'updating' stamp: 'reThink 3/9/2001 20:46'!
refreshWindow

        self passFailText color: Color white.
        self detailsText color: Color white.
        self updateErrors: TestResult new.
        self updateFailures: TestResult new.
        self displayPassFail: 'N/A'.
        self displayDetails: '...'! !

!TestRunner methodsFor: 'updating' stamp: 'reThink 3/9/2001 20:46'!
runWindow

	self passFailText color: Color white.
	self detailsText color: Color white.
	self updateErrors: TestResult new.
	self updateFailures: TestResult new.
	self displayPassFail: 'Running...'.
	self displayDetails: '...'! !

!TestRunner methodsFor: 'updating' stamp: 'Sames 4/12/2000 18:20'!
updateDetails: aTestResult
        self displayDetails: aTestResult printString , (self
timeSinceLastPassAsString: aTestResult).
        aTestResult hasPassed ifTrue: [lastPass _ Time now]! !

!TestRunner methodsFor: 'updating' stamp: 'Sames 4/11/2000 17:35'!
updateErrors: aTestResult

        self displayErrors: (aTestResult errors collect: [:error | error
printString])! !

!TestRunner methodsFor: 'updating' stamp: 'Sames 4/11/2000 17:35'!
updateFailures: aTestResult

        self displayFailures: (aTestResult failures collect: [:failure |
failure printString])! !

!TestRunner methodsFor: 'updating' stamp: 'reThink 3/9/2001 20:47'!
updatePartColors: aColor 

	self passFailText color: aColor.
	self detailsText color: aColor! !

!TestRunner methodsFor: 'updating' stamp: 'Sames 4/11/2000 18:27'!
updatePassFail: aTestResult
        | message |
        message _ aTestResult hasPassed
                                ifTrue: ['Pass']
                                ifFalse: ['Fail'].
        self displayPassFail: message! !

!TestRunner methodsFor: 'updating' stamp: 'Sames 4/12/2000 18:54'!
updateWindow: aTestResult
        aTestResult errors size + aTestResult failures size = 0
                ifTrue: [self updatePartColors: self passColor]
                ifFalse: [aTestResult errors size > 0
                                ifTrue: [self updatePartColors: self
errorColor]
                                ifFalse: [self updatePartColors: self
failColor]].
        self updatePassFail: aTestResult.
        self updateDetails: aTestResult.
        self updateFailures: aTestResult.
        self updateErrors: aTestResult! !

!TestRunner methodsFor: 'test processing' stamp: 'rhi 4/26/2000 07:51'!
runTests: aString
	"doIt: [TestRunner new runTests: 'Test* test*']"

	self
		classPattern: (self classPatternFrom: aString);
		selectorPattern: (self selectorPatternFrom: aString).
	self runTests.! !

!TestRunner methodsFor: 'test processing' stamp: 'rhi 2/5/2000 12:45'!
showResult

	Transcript cr;cr; show: '==== SUnit ======== Start ===='.
	self
		showResultSummary;
		showResultDefects.
	Transcript cr; show: '==== SUnit ========== End ===='; cr.! !

!TestRunner methodsFor: 'test processing' stamp: 'rhi 2/5/2000 12:45'!
showResultDefects

	(self result failureCount > 0)
		ifTrue: [
			Transcript cr; show: '---- SUnit ----- Failures ----'.
			self result failures do: [:failure |
				Transcript crtab; show: failure printString]].
	(self result errorCount > 0)
		ifTrue: [
			Transcript cr; show: '---- SUnit ------- Errors ----'.
			self result errors do: [:error |
				Transcript crtab; show: error printString]].! !

!TestRunner methodsFor: 'test processing' stamp: 'rhi 2/5/2000 12:45'!
showResultSummary

	| message summary |
	message := (self result runCount = self result correctCount)
		ifTrue: [self successMessage]
		ifFalse: [self failureMessage].
	Transcript crtab; show: message.
	summary :=
		self result runCount printString, ' run, ',
		self result failureCount printString, ' failed, ',
		self result errorCount printString, ' errors (',
		self duration printString, ' ms)'.
	Transcript crtab; show: summary.! !


!TestRunner class methodsFor: 'instance creation' stamp: 'Sames 4/11/2000
17:33'!
new

        ^super new initialize! !

!TestRunner class methodsFor: 'documentation' stamp: 'rhi 2/5/2000 12:40'!
testRunnerUsage
	"Please see the class comment for some documentation.

	Documentation links:
		* TestingFrameworkPaper
		* TestModel
		* TestRunner"

	self error: 'comment only'.! !

!TestRunner class methodsFor: 'processing' stamp: 'rhi 2/5/2000 12:40'!
runTests
	"doIt: [TestRunner runTests]"

	TestRunner new runTests.! !

!TestRunner class methodsFor: 'processing' stamp: 'rhi 2/5/2000 12:40'!
runTests: aString
	"doIt: [TestRunner runTests: '* test*']"

	TestRunner new runTests: aString.! !

!TestRunner class methodsFor: 'accessing' stamp: 'reThink 3/9/2001 20:01'!
defaultViewSpecification

	^'<?xml version="1.0" encoding="ISO-8859-1"?>
<window title="windowLabel" initialExtent="600@380">
	<buttonWidget label="Run All">
			<pluginButton state="runButtonState" action="runTests"/>
			<frame leftFraction="4/5" topFraction="1/10" rightFraction="1" bottomFraction="1/5"/>
	</buttonWidget>
	<buttonWidget label="Run">
			<pluginButton state="runButtonState" action="runOneTest"/>
			<frame leftFraction="4/5" topFraction="0" rightFraction="1" bottomFraction="1/10"/>
	</buttonWidget>
	<buttonWidget label="Refresh">
			<pluginButton state="refreshButtonState" action="refreshTests"/>
			<frame leftFraction="0" topFraction="0" rightFraction="1/5" bottomFraction="1/5"/>
	</buttonWidget>
	<textWidget>
		<pluginText text="passFail"/>
		<frame leftFraction="0" topFraction="1/5" rightFraction="1" bottomFraction="3/10"/>
	</textWidget>
	<textWidget>
		<pluginText text="details"/>
		<frame leftFraction="0" topFraction="3/10" rightFraction="1" bottomFraction="2/5"/>
	</textWidget>
	<listWidget>
		<pluginList list="tests" index="selectedSuite" setIndex="selectedSuite:" />
		<frame leftFraction="1/5" topFraction="0" rightFraction="4/5" bottomFraction="1/5"/>
	</listWidget>
 	<listWidget>
		<pluginList list="failures" setIndex="debugFailureTest:" />
		<frame leftFraction="0" topFraction="2/5" rightFraction="1" bottomFraction="7/10"/>
	</listWidget>
 	<listWidget>
		<pluginList list="errors" index="selectedErrorTest" setIndex="debugErrorTest:" />
		<frame leftFraction="0" topFraction="7/10" rightFraction="1" bottomFraction="1"/>
	</listWidget>
</window>'
! !

Behavior removeSelector: #sunitAllSelectors!
